#!/bin/bash

# Some code comes from liblinuxlive from Tomas M. <http://www.linux-live.org>

WIN_DIR=([wW][iI][nN][dD][oO][wW][sS] [wW][iI][nN][nN][tT] [wW][iI][nN][xX][pP] [wW][iI][nN][dD][oO][wW][sS]2003 [wW][iI][nN]2003 [wW][iI][nN]2[kK])

SYSTEMCONFIG_DIR=[sS][yY][sS][tT][eE][mM]32/[cC][oO][nN][fF][iI][gG]

# GUI or not ?

if [ "$1" = "0" ]
then
    opts="-g"
else
    opts="-r -- -geometry 745x550"
fi

#Find all the libs
ldconfig

#Check the number of CPUs

numcpu=`cat /proc/cpuinfo | grep ^processor | wc -l`
numcpu=$(( $numcpu + 1 ))

#Check where the tables are located

# List all devices with filesystems
# Return empty result when nohd parameter was given.
#
list_partition_devices()
{
    cat /proc/partitions | grep -v loop | sed -r "s/^[0-9 ]+/\\/dev\\//" | grep /dev/
}

# List all disk devices
#
list_disk_devices()
{
   list_partition_devices | egrep -v "[0-9]"
}
# List all CD-ROMs
# by using /proc entries
#
list_cdrom_devices()
{
   for CDDEVICE in `cat /proc/sys/dev/cdrom/info 2>/dev/null | head -n 3 | tail -n 1 | cut -d ":" -f 2`; do
      echo "/dev/$CDDEVICE"
   done
}
# List all block devices
#
list_block_devices()
{
   list_cdrom_devices
   list_partition_devices
}

# Try to mount all disks, partitions and cdroms and Find where the LiveCD is.
# If LiveCD found in the device, echo dirname of it's directory,
# and leave the device mounted. Mounting is not ro, but without any argument.
# $1 = directory where devices will be mounted
#
find_live_data_dir()
{
   list_block_devices | while read DEVICE; do
      DIR="/mnt/live/mnt/`basename $DEVICE`"
      FOUND=`ls -A1d $DIR/livecd.sgn $DIR/*/livecd.sgn 2>/dev/null | head -n 1`
      if [ "$FOUND" != "" ]; then dirname "$FOUND"; return 1; fi
   done
}

LIVECD_DIR=`find_live_data_dir`

for DEVICE in `list_partition_devices`
do 
  mount -r /mnt/`basename $DEVICE` 2>/dev/null
  for i in 0 1 2 3 4 5
    do
    DIR="/mnt/`basename $DEVICE`/${WIN_DIR[i]}/$SYSTEMCONFIG_DIR"
    DIR_LS=`ls -d $DIR 2>/dev/null`
    if [ $DIR_LS ]; then FOUND_DIR[${#FOUND_DIR[*]}]=$DIR_LS; fi
  done
done

if [ ${#FOUND_DIR[*]} = 0 ]; then
    echo "No partition containing hashes found !!"
    read
    exit 0
elif [ ${#FOUND_DIR[*]} = 1 ]; then
    echo "Found one partition that contains hashes:"
    echo ""
    echo "  ${FOUND_DIR[0]}"
    echo ""
    FOUND=${FOUND_DIR[0]}
else
    echo "List of Windows partitions containing hashes:"
    echo ""
    for ((  i = 0 ;  i < ${#FOUND_DIR[*]};  i++  ))  
      do
      echo "   $i. ${FOUND_DIR[i]}"
    done
    echo ""
    echo "Select the partition to crack: "
    read entry
    FOUND=${FOUND_DIR[$entry]}
fi

echo "Starting Ophcrack"
ophcrack -d $LIVECD_DIR/ -t tables:tables_vista -w $FOUND/ -n $numcpu -o /tmp/ophcrack.txt $opts 

if [ "$1" = "0" ]; then
    echo "The passwords have been saved in /tmp/ophcrack.tmp";
fi
  
echo "Press a key to exit..."
read
echo ""
echo "Shutdown (y/n)?"
read answer
if [ "$answer" = "y" ]; then
    poweroff;
fi
echo "Enter \"poweroff\" to shut down later...";
